package com.skywang.control;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.widget.Toast;
import android.widget.Button;
import android.widget.EditText;
import android.view.View;
import android.view.View.OnClickListener;
import android.util.Log;
import android.text.TextUtils;
import android.text.Spannable;
import android.text.Selection;

public class EditTextTest extends Activity implements View.OnClickListener{
	private static final String TAG = "SKYWANG";
	
	private EditText mEdit;
	private Button mBtnShow;
	private Button mBtnDelete;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.edit_text_test);
        
        // 获取edittext
        mEdit = (EditText)findViewById(R.id.edit_test);
        
        // 获取show按钮
        mBtnShow = (Button)findViewById(R.id.btn_show);
        // 设置show按钮的监听函数
        mBtnShow.setOnClickListener(this);
        
        // 获取delete按钮
        mBtnDelete = (Button)findViewById(R.id.btn_delete);
        // 设置delete按钮的监听函数
        mBtnDelete.setOnClickListener(this);
        
        // 打印log信息
        Log.d(TAG, "on create");
    }
    
    @Override
    public void onClick(View v) {
    	switch(v.getId()) {
	    	case R.id.btn_show: {
	    		Log.d(TAG, "click button show! text:"+mEdit.getText().toString());
	    		Toast.makeText(getApplicationContext(), mEdit.getText().toString(), Toast.LENGTH_LONG).show();
	    		break;	
	    	}
	    	case R.id.btn_delete: {
	    		if (!TextUtils.isEmpty(mEdit.getText())) {
		    		String text = mEdit.getText().toString();
		    		int len = text.length() - 1;
		    		mEdit.setText(mEdit.getText().subSequence(0, len));
		    		// 设置光标位置
		    		setEditTextIndicator(mEdit, mEdit.length());
	    		}
	    		
	    		break;	
	    	}
    	}
    }
    
    /*
     * 设置EditText光标位置。
     * 若输入的光标位置无效，则将光标设置到EditText末尾。
     * 参数说明：
     *     et —— 被设置的EditText
     *     index —— 设置后的光标位置
     */
    private void setEditTextIndicator (EditText et, int index) {
        CharSequence text = et.getText();
        if (text instanceof Spannable) {
            Spannable spanText = (Spannable)text;
            
            try {
            	Selection.setSelection(spanText, index);
            }catch (IndexOutOfBoundsException e) {
            	Selection.setSelection(spanText, text.length());
            }
        }    
    }
}
